var searchURL;

var advancedOptions = {
   fileType: false,
   webHistory: false,
   email: false,
   chat: false
};

var flagValues = {
   flag_all: 8, // This is the default flag value
   flag_web: 256,
   flag_files: 512,
   flag_email: 1024,
   flag_chat: 2048,
   flag_other_contacts: 32768,
   flag_other_calendar: 65536,
   flag_other_tasks: 131136,
   flag_other_notes: 262208,
   flag_other_journal: 524352,
   flag_other_all: 1015808,
   flag_by_date: 0,
   flag_by_relevance: 16,
   flag_show_calendar: 16384
};
   
window.addEventListener("load", function() { initSearchURL(); }, false);

function initSearchURL()
{
   //alert("In initSearchURL()");
   document.getElementById("other_menu").addEventListener("ValueChange", setOtherType, false);
   var searchKey=Components.classes["@mozilla.org/windows-registry-key;1"].createInstance(Components.interfaces.nsIWindowsRegKey);
   searchKey.open(searchKey.ROOT_KEY_CURRENT_USER,"Software\\Google\\Google Desktop\\API\\",searchKey.ACCESS_QUERY_VALUE);
   searchURL=searchKey.readStringValue("search_url");
   document.getElementById("searchbox").focus();
}

function webSearch()
{
   var inBox=document.getElementById('searchbox');
   var currentdoc=Components.classes["@mozilla.org/appshell/window-mediator;1"].getService(Components.interfaces.nsIWindowMediator).getMostRecentWindow("navigator:browser").content;
   currentdoc.location = "http://www.google.com/search?q="+inBox.value;
}

function toggleFileType()
{
   var toggleState=document.getElementById("filetypeindicator");
   var fileTypeInput=document.getElementById("filetypeinput");
   fileTypeInput.disabled = !toggleState.checked; //checked==true => disabled==false
   advancedOptions.fileType = toggleState.checked;
   var flagbox=document.getElementById("flags");
   flagbox.disabled = toggleState.checked;
   fileTypeInput.focus();
}

function toggleWebHistory()
{
   var toggleState=document.getElementById("webhistoryindicator");
   advancedOptions.webHistory = toggleState.checked;
}
   
function toggleAdvanced()
{
   var toggleAdvanced=document.getElementById("advanced").checked;
   var command=document.getElementById("toggledisable");
   if(toggleAdvanced==true)
      {
      command.removeAttribute("hidden");
      command.removeAttribute("disabled");
      toggleFileType(); //needed to set the filetype text box's attributes correctly
      }
   else
      {
      command.setAttribute("hidden","true");
      command.setAttribute("disabled","true");
      }
}

function toggleOther()
{
   var toggleOther=document.getElementById("flag_other").selected;
   var command=document.getElementById("toggleother");
   if(toggleOther==true)
      {
      command.removeAttribute("hidden");
      command.removeAttribute("disabled");
      }
   else
      {
      command.setAttribute("hidden","true");
      command.setAttribute("disabled","true");
      }
}

function setOtherType()
{
   var other=document.getElementById('flag_other');
   var other_type=document.getElementById('other_menu');
   //alert("in setOtherType()");
   other.value=other_type.selectedItem.id;
}

function doSearch() // Works like a charm
   {
   var flag_default = flagValues.flag_all;
   var inBox=document.getElementById('searchbox');
   var fileType=document.getElementById("filetypeinput");
   var currentdoc=Components.classes["@mozilla.org/appshell/window-mediator;1"].getService(Components.interfaces.nsIWindowMediator).getMostRecentWindow("navigator:browser").content;
   var searchString=inBox.value;
   var radio_box=document.getElementById("toggledisable");
   if(radio_box.hasAttribute("disabled") != true) //if advanced options are active
      {
      type_flag=flagValues.flag_all;
      sort_flag=flagValues[document.getElementById("sort_order").selectedItem.id];
      //alert("sort_flag="+sort_flag);
      calendar_flag=0;
      if(document.getElementById("flag_show_calendar").checked == true)
         {
         calendar_flag=flagValues.flag_show_calendar;
         //alert("calendar_flag="+calendar_flag);
         }
      if(fileType.disabled==false && fileType.value!="") //filetype takes precedence over flagged options
         {
         flag_total=sort_flag+calendar_flag;
         currentdoc.location=searchURL+searchString+" filetype:"+fileType.value+"&flags="+flag_total;
         }
      else
         {
         type_flag=flagValues[document.getElementById("flags").selectedItem.value];
         //alert("type_flag="+type_flag)
         flag_total=type_flag+sort_flag+calendar_flag
         //alert("flag_total="+flag_total)
         currentdoc.location=searchURL+searchString+"&flags="+flag_total;
         }
      }
   else
      currentdoc.location=searchURL+searchString+"&flags="+flagValues.flag_all;
   }
